<?php
namespace Util\Instance;

use Util\Utilities;
use Zeedhi\Framework\DependencyInjection\InstanceManager;

class RepositoryInstance {

    /** @return \Repository\Table */
    public static function getTable()
    {
        return InstanceManager::getInstance()->getService('\Repository\Table');
    }

    public static function getProcedure()
    {
        return InstanceManager::getInstance()->getService('\Repository\Procedure');
    }

    public static function getTrigger()
    {
        return InstanceManager::getInstance()->getService('\Repository\Trigger');
    }

    public static function getView()
    {
        return InstanceManager::getInstance()->getService('\Repository\View');
    }

    public static function getFunctions()
    {
        return InstanceManager::getInstance()->getService('\Repository\Functions');
    }

    public static function getObjects()
    {
        return InstanceManager::getInstance()->getService('\Repository\Objects');
    }

    public static function getSequence()
    {
        return InstanceManager::getInstance()->getService('\Repository\Sequence');
    }

    public static function getIndex()
    {
        return InstanceManager::getInstance()->getService('\Repository\Index');
    }

    public static function getJob()
    {
        return InstanceManager::getInstance()->getService('\Repository\Job');
    }

    /** @return \Repository\Structure */
    public static function getStructure()
    {
        return InstanceManager::getInstance()->getService('\Repository\Structure');
    }

    /** @return \Repository\Repositorio */
    public static function getRepositorio()
    {
        return InstanceManager::getInstance()->getService('\Repository\Repositorio');
    }

    /** @return \Teknisa\Model\Geral\Repositories\Operador */
    public static function getOperador()
    {
        return GeneralProvider::getEntityManager()->getRepository(Utilities::GERAL_ENTITY_DIR . 'Operador');
    }

    /** @return \Teknisa\Model\Teknisa\Repositories\MtRepositorio */
    public static function getMtRepositorio()
    {
        return GeneralProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'MtRepositorio');
    }

    /** @return \Teknisa\Model\Teknisa\Repositories\MtDesignEstrutura */
    public static function getMtDesignEstrutura()
    {
        return GeneralProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'MtDesignEstrutura');
    }
    
    /** @return \Teknisa\Model\Teknisa\Repositories\MtDesignEstruturaTask */
    public static function getMtDesignEstruturaTask()
    {
        return GeneralProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'MtDesignEstruturaTask');
    }

    /** @return \Teknisa\Model\Geral\Repositories\Tabela */
    public static function getTabela()
    {
        return GeneralProvider::getEntityManager()->getRepository(Utilities::GERAL_ENTITY_DIR . 'Tabela');
    }
    /** @return \Teknisa\Model\Geral\Repositories\Coluna */
    public static function getColuna()
    {
        return GeneralProvider::getEntityManager()->getRepository(Utilities::GERAL_ENTITY_DIR . 'Coluna');
    }
    /** @return \Teknisa\Model\Geral\Repositories\Objeto */
    public static function getObjeto()
    {
        return GeneralProvider::getEntityManager()->getRepository(Utilities::GERAL_ENTITY_DIR . 'Objeto');
    }
    /** @return \Teknisa\Model\Teknisa\Repositories\MtDesignEstruturaScript */
    public static function getMtDesignEstruturaScript()
    {
        return GeneralProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'MtDesignEstruturaScript');
    }

    /** @return \Teknisa\Model\Teknisa\Repositories\MtRepositorioOperador */
    public static function getMtRepositorioOperador()
    {
        return GeneralProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'MtRepositorioOperador');
    }
}