CREATE OR REPLACE FUNCTION ARQUIVO_DPI_SAIDA(
   P_CDIMPOSTO    IN IMPOSTO.CDIMPOSTO%TYPE,
   P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
   P_DTINICIAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL      IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_CDINSCESTA   IN NOTAFISCAL.CDINSCESTA%TYPE,
   P_CONTADOR     IN NUMBER,
   P_SEQMAGNET    IN VARCHAR)
RETURN NUMBER
AS
   V_CONTADOR       NUMBER;
   V_CDIMPOSTRIB    VARCHAR2(2);
   V_DATAINICIAL    DATE;
   V_DATAFIM        DATE;
   V_COUNT          NUMBER;
   V_CDPAIS         VARCHAR2(4);

BEGIN
   V_CONTADOR := NVL(P_CONTADOR,0);
   V_COUNT := 0;

   V_DATAINICIAL := TO_DATE('01/01/'|| SUBSTR(P_DTINICIAL,7,10));
   V_DATAFIM     := TO_DATE('31/12/'|| SUBSTR(P_DTFINAL,7,10));


   /* IMPOSTO COM SUBSTITUIO TRIBUTRIA */
   V_CDIMPOSTRIB := '80';

   BEGIN
      SELECT CDPAIS
        INTO V_CDPAIS
        FROM PAIS
       WHERE NMPAIS LIKE UPPER('BRASIL');
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CDPAIS := NULL;
   END;

   FOR C_REGISTRO_11 IN(
      SELECT E.SGESTADO AS SGESTADO,
             '0~' AS VRCTBNAO_CONTRIBUINTE,
             NVL(T.VRCONTABILNF,0)||'~' AS VRCONTABILNF,
             '0~' AS VRBCLNAO_CONTRIBUINTE,
             NVL(T.VRBASECALCNF,0)||'~' AS VRBASECALCNF,
             NVL(T.OUTRAS,0)||'~' AS OUTRAS,
             NVL(T.SUBST,0)||'~' AS SUBST
        FROM ESTADO E,
            (SELECT E.SGESTADO,
                    SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                    SUM(I.VRBASECALCNF) AS VRBASECALCNF,
                    SUM(DECODE(I.CDFISCALNF,3,I.VRCONTABILNF,0)) AS OUTRAS,
                    SUM(VALOR_IMPOSTO_NFE(N.CDFILIAL,N.NRLANCTONF,V_CDIMPOSTRIB,'I')) AS SUBST
               FROM MAPAAPURAC M, IMPOSTONF I, NOTAFISCAL N, FORNECEDOR F, ENDEFORN E, IMPOSTO IM
              WHERE M.CDEMPRESA     = P_CDEMPRESA
                AND M.CDINSCESTA    = P_CDINSCESTA
                AND M.CDIMPOSTO     = P_CDIMPOSTO
                AND M.DTINIPERIODO >= V_DATAINICIAL
                AND M.DTFIMPERIODO <= V_DATAFIM
                AND M.NRSEQUMAPAPU  = I.NRSEQUMAPAPU
                AND M.CDIMPOSTO     = IM.CDIMPOSTONFE
                AND IM.CDIMPOSTO    = I.CDIMPOSTO
                AND I.CDFILIAL      = N.CDFILIAL
                AND I.NRLANCTONF    = N.NRLANCTONF
                AND N.CDFORNECED    = F.CDFORNECED
                AND F.CDFORNECED    = E.CDFORNECED
                AND ((IDIMPOSTONF <> '3') OR (IDIMPOSTONF IS NULL))
                AND E.IDTPENDEFORN  = 'P'
                AND N.IDENTRSAIDOP  = 'S'
                AND N.IDORIGDESTNF  = 'F'
              GROUP BY E.SGESTADO
            UNION ALL
            SELECT E.SGESTADO,
                   SUM (I.VRCONTABILNF) AS VRCONTABILNF,
                   SUM (I.VRBASECALCNF) AS VRBASECALCNF,
                   SUM (DECODE(I.CDFISCALNF,3,I.VRCONTABILNF,0)) AS OUTRAS,
                   SUM (VALOR_IMPOSTO_NFE(N.CDFILIAL,N.NRLANCTONF,V_CDIMPOSTRIB,'I')) AS SUBST
              FROM MAPAAPURAC M, IMPOSTONF I, NOTAFISCAL N, FILIAL F, ENDEFILI E, IMPOSTO IM
             WHERE M.CDEMPRESA     = P_CDEMPRESA
               AND M.CDINSCESTA    = P_CDINSCESTA
               AND M.CDIMPOSTO     = P_CDIMPOSTO
               AND M.DTINIPERIODO >= V_DATAINICIAL
               AND M.DTFIMPERIODO <= V_DATAFIM
               AND M.NRSEQUMAPAPU  = I.NRSEQUMAPAPU
               AND M.CDIMPOSTO     = IM.CDIMPOSTONFE
               AND IM.CDIMPOSTO    = I.CDIMPOSTO
               AND I.CDFILIAL      = N.CDFILIAL
               AND I.NRLANCTONF    = N.NRLANCTONF
               AND N.CDFILIEMIT    = F.CDFILIAL
               AND F.CDFILIAL      = E.CDFILIAL
               AND ((IDIMPOSTONF <> '3') OR (IDIMPOSTONF IS NULL))
               AND E.IDTPENDEFILI  = 'P'
               AND N.IDENTRSAIDOP  = 'S'
               AND N.IDORIGDESTNF  = 'L'
             GROUP BY E.SGESTADO
            UNION ALL
            SELECT E.SGESTADO,
                   SUM (I.VRCONTABILNF) AS VRCONTABILNF,
                   SUM (I.VRBASECALCNF) AS VRBASECALCNF,
                   SUM (DECODE(I.CDFISCALNF,3,I.VRCONTABILNF,0)) AS OUTRAS,
                   SUM (VALOR_IMPOSTO_NFE(N.CDFILIAL,N.NRLANCTONF,V_CDIMPOSTRIB,'I')) AS SUBST
              FROM MAPAAPURAC M, IMPOSTONF I, NOTAFISCAL N, CLIENTE C, ENDECLIE E, IMPOSTO IM
             WHERE M.CDEMPRESA     = P_CDEMPRESA
               AND M.CDINSCESTA    = P_CDINSCESTA
               AND M.CDIMPOSTO     = P_CDIMPOSTO
               AND M.DTINIPERIODO >= V_DATAINICIAL
               AND M.DTFIMPERIODO <= V_DATAFIM
               AND M.NRSEQUMAPAPU  = I.NRSEQUMAPAPU
               AND M.CDIMPOSTO     = IM.CDIMPOSTONFE
               AND IM.CDIMPOSTO    = I.CDIMPOSTO
               AND I.CDFILIAL      = N.CDFILIAL
               AND I.NRLANCTONF    = N.NRLANCTONF
               AND N.CDCLIENTE     = C.CDCLIENTE
               AND C.CDCLIENTE     = E.CDCLIENTE
                AND ((IDIMPOSTONF <> '3') OR (IDIMPOSTONF IS NULL))
               AND E.IDTPENDECLIE  = 'P'
               AND N.IDENTRSAIDOP  = 'S'
               AND N.IDORIGDESTNF  = 'C'
             GROUP BY E.SGESTADO)T
       WHERE E.SGESTADO = T.SGESTADO(+)
         AND E.CDPAIS = V_CDPAIS
         AND E.SGESTADO <> 'GO'
       ORDER BY E.NMESTADO) LOOP

       /*OS VALORES SERO INSERIDOS UM ABAIXO DO OUTRO NA ORDEM A SEGUIR*/

       V_CONTADOR := NVL(V_CONTADOR,0)+1;
       INSERT INTO ARQMAGNETICO
          (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
          VALUES
          ('92'||LPAD(V_CONTADOR, 8, '0'),C_REGISTRO_11.VRCTBNAO_CONTRIBUINTE,P_SEQMAGNET);

       V_CONTADOR := NVL(V_CONTADOR,0)+1;
       INSERT INTO ARQMAGNETICO
          (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
          VALUES
          ('92'||LPAD(V_CONTADOR, 8, '0'),C_REGISTRO_11.VRCONTABILNF,P_SEQMAGNET);

       V_CONTADOR := NVL(V_CONTADOR,0)+1;
       INSERT INTO ARQMAGNETICO
          (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
          VALUES
          ('92'||LPAD(V_CONTADOR, 8, '0'),C_REGISTRO_11.VRBCLNAO_CONTRIBUINTE,P_SEQMAGNET);

       V_CONTADOR := NVL(V_CONTADOR,0)+1;
       INSERT INTO ARQMAGNETICO
          (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
          VALUES
          ('92'||LPAD(V_CONTADOR, 8, '0'),C_REGISTRO_11.VRBASECALCNF,P_SEQMAGNET);

       V_CONTADOR := NVL(V_CONTADOR,0)+1;
       INSERT INTO ARQMAGNETICO
          (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
          VALUES
          ('92'||LPAD(V_CONTADOR, 8, '0'),C_REGISTRO_11.OUTRAS,P_SEQMAGNET);

       V_CONTADOR := NVL(V_CONTADOR,0)+1;
       INSERT INTO ARQMAGNETICO
          (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
          VALUES
          ('92'||LPAD(V_CONTADOR, 8, '0'),C_REGISTRO_11.SUBST,P_SEQMAGNET);

   END LOOP;
/*SELECT NECESSRIO POIS SOMENTE O ESTADO DE GOIS EST DESORDENADO NO LAYOUT*/
   FOR C_REGISTRO_GO IN(
      SELECT E.SGESTADO AS SGESTADO,
             '0~' AS VRCTBNAO_CONTRIBUINTE,
             NVL(T.VRCONTABILNF,0)||'~' AS VRCONTABILNF,
             '0~' AS VRBCLNAO_CONTRIBUINTE,
             NVL(T.VRBASECALCNF,0)||'~' AS VRBASECALCNF,
             NVL(T.OUTRAS,0)||'~' AS OUTRAS,
             NVL(T.SUBST,0)||'~' AS SUBST
        FROM ESTADO E,
            (SELECT E.SGESTADO,
                    SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                    SUM(I.VRBASECALCNF) AS VRBASECALCNF,
                    SUM(DECODE(I.CDFISCALNF,3,I.VRCONTABILNF,0)) AS OUTRAS,
                    SUM(VALOR_IMPOSTO_NFE(N.CDFILIAL,N.NRLANCTONF,V_CDIMPOSTRIB,'I')) AS SUBST
               FROM MAPAAPURAC M, IMPOSTONF I, NOTAFISCAL N, FORNECEDOR F, ENDEFORN E, IMPOSTO IM
              WHERE M.CDEMPRESA     = P_CDEMPRESA
                AND M.CDINSCESTA    = P_CDINSCESTA
                AND M.CDIMPOSTO     = P_CDIMPOSTO
                AND M.DTINIPERIODO >= V_DATAINICIAL
                AND M.DTFIMPERIODO <= V_DATAFIM
                AND M.NRSEQUMAPAPU  = I.NRSEQUMAPAPU
                AND M.CDIMPOSTO     = IM.CDIMPOSTONFE
                AND IM.CDIMPOSTO    = I.CDIMPOSTO
                AND I.CDFILIAL      = N.CDFILIAL
                AND I.NRLANCTONF    = N.NRLANCTONF
                AND N.CDFORNECED    = F.CDFORNECED
                AND F.CDFORNECED    = E.CDFORNECED
                AND ((IDIMPOSTONF <> '3') OR (IDIMPOSTONF IS NULL))
                AND E.IDTPENDEFORN  = 'P'
                AND N.IDENTRSAIDOP  = 'S'
                AND N.IDORIGDESTNF  = 'F'
              GROUP BY E.SGESTADO
            UNION ALL
            SELECT E.SGESTADO,
                   SUM (I.VRCONTABILNF) AS VRCONTABILNF,
                   SUM (I.VRBASECALCNF) AS VRBASECALCNF,
                   SUM (DECODE(I.CDFISCALNF,3,I.VRCONTABILNF,0)) AS OUTRAS,
                   SUM (VALOR_IMPOSTO_NFE(N.CDFILIAL,N.NRLANCTONF,V_CDIMPOSTRIB,'I')) AS SUBST
              FROM MAPAAPURAC M, IMPOSTONF I, NOTAFISCAL N, FILIAL F, ENDEFILI E, IMPOSTO IM
             WHERE M.CDEMPRESA     = P_CDEMPRESA
               AND M.CDINSCESTA    = P_CDINSCESTA
               AND M.CDIMPOSTO     = P_CDIMPOSTO
               AND M.DTINIPERIODO >= V_DATAINICIAL
               AND M.DTFIMPERIODO <= V_DATAFIM
               AND M.NRSEQUMAPAPU  = I.NRSEQUMAPAPU
               AND M.CDIMPOSTO     = IM.CDIMPOSTONFE
               AND IM.CDIMPOSTO    = I.CDIMPOSTO
               AND I.CDFILIAL      = N.CDFILIAL
               AND I.NRLANCTONF    = N.NRLANCTONF
               AND N.CDFILIEMIT    = F.CDFILIAL
               AND F.CDFILIAL      = E.CDFILIAL
               AND ((IDIMPOSTONF <> '3') OR (IDIMPOSTONF IS NULL))
               AND E.IDTPENDEFILI  = 'P'
               AND N.IDENTRSAIDOP  = 'S'
               AND N.IDORIGDESTNF  = 'L'
             GROUP BY E.SGESTADO
            UNION ALL
            SELECT E.SGESTADO,
                   SUM (I.VRCONTABILNF) AS VRCONTABILNF,
                   SUM (I.VRBASECALCNF) AS VRBASECALCNF,
                   SUM (DECODE(I.CDFISCALNF,3,I.VRCONTABILNF,0)) AS OUTRAS,
                   SUM (VALOR_IMPOSTO_NFE(N.CDFILIAL,N.NRLANCTONF,V_CDIMPOSTRIB,'I')) AS SUBST
              FROM MAPAAPURAC M, IMPOSTONF I, NOTAFISCAL N, CLIENTE C, ENDECLIE E, IMPOSTO IM
             WHERE M.CDEMPRESA     = P_CDEMPRESA
               AND M.CDINSCESTA    = P_CDINSCESTA
               AND M.CDIMPOSTO     = P_CDIMPOSTO
               AND M.DTINIPERIODO >= V_DATAINICIAL
               AND M.DTFIMPERIODO <= V_DATAFIM
               AND M.NRSEQUMAPAPU  = I.NRSEQUMAPAPU
               AND M.CDIMPOSTO     = IM.CDIMPOSTONFE
               AND IM.CDIMPOSTO    = I.CDIMPOSTO
               AND I.CDFILIAL      = N.CDFILIAL
               AND I.NRLANCTONF    = N.NRLANCTONF
               AND N.CDCLIENTE     = C.CDCLIENTE
               AND C.CDCLIENTE     = E.CDCLIENTE
                AND ((IDIMPOSTONF <> '3') OR (IDIMPOSTONF IS NULL))
               AND E.IDTPENDECLIE  = 'P'
               AND N.IDENTRSAIDOP  = 'S'
               AND N.IDORIGDESTNF  = 'C'
             GROUP BY E.SGESTADO)T
       WHERE E.SGESTADO = T.SGESTADO(+)
         AND E.CDPAIS = V_CDPAIS
         AND E.SGESTADO = 'GO') LOOP

       V_CONTADOR := NVL(V_CONTADOR,0)+1;
       INSERT INTO ARQMAGNETICO
          (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
          VALUES
          ('92'||LPAD(V_CONTADOR, 8, '0'),C_REGISTRO_GO.VRCTBNAO_CONTRIBUINTE,P_SEQMAGNET);

       V_CONTADOR := NVL(V_CONTADOR,0)+1;
       INSERT INTO ARQMAGNETICO
          (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
          VALUES
          ('92'||LPAD(V_CONTADOR, 8, '0'),C_REGISTRO_GO.VRCONTABILNF,P_SEQMAGNET);

       V_CONTADOR := NVL(V_CONTADOR,0)+1;
       INSERT INTO ARQMAGNETICO
          (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
          VALUES
          ('92'||LPAD(V_CONTADOR, 8, '0'),C_REGISTRO_GO.VRBCLNAO_CONTRIBUINTE,P_SEQMAGNET);

       V_CONTADOR := NVL(V_CONTADOR,0)+1;
       INSERT INTO ARQMAGNETICO
          (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
          VALUES
          ('92'||LPAD(V_CONTADOR, 8, '0'),C_REGISTRO_GO.VRBASECALCNF,P_SEQMAGNET);

       V_CONTADOR := NVL(V_CONTADOR,0)+1;
       INSERT INTO ARQMAGNETICO
          (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
          VALUES
          ('92'||LPAD(V_CONTADOR, 8, '0'),C_REGISTRO_GO.OUTRAS,P_SEQMAGNET);

       V_CONTADOR := NVL(V_CONTADOR,0)+1;
       INSERT INTO ARQMAGNETICO
          (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
          VALUES
          ('92'||LPAD(V_CONTADOR, 8, '0'),C_REGISTRO_GO.SUBST,P_SEQMAGNET);
      END LOOP;

      WHILE (V_COUNT <= 5) LOOP
          V_CONTADOR := NVL(V_CONTADOR,0)+1;
       INSERT INTO ARQMAGNETICO
          (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
          VALUES
          ('92'||LPAD(V_CONTADOR, 8, '0'),'0~',P_SEQMAGNET);
           V_COUNT := V_COUNT + 1;
      END LOOP;

RETURN (LPAD(V_CONTADOR, 10, 0));
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_DPI_SAIDA','5.30.000'); END;
/

