/* Sistemas Integrados TECNISA
   Planejamento Alimentao Industrial

Nome: LIMPA_TABELAS_PLA

Descrio:
Limpeza das tabelas do sistema Planejamento Alimentao Industrial.

Criao:
19/12/2005 - Daniel Lage Guerra

*/
IF EXISTS (SELECT * FROM sysobjects O, sysusers U
           WHERE
            o.name = 'LIMPA_TABELAS_PLA'  and
            type = 'P'                        and
            u.uid = o.uid                     and
            u.name = USER)

   DROP PROCEDURE LIMPA_TABELAS_PLA;
GO

CREATE PROCEDURE LIMPA_TABELAS_PLA
  (@P_NRLISTA       VARCHAR(10),
   @P_DTFINAL       DATETIME,
   @P_DSSISTLIMPEZ  VARCHAR(60),
   @P_NMOPERLIMPEZ  VARCHAR(40))
AS

   DECLARE @V_ERR0R          VARCHAR(2000);
   DECLARE @V_DSIP           VARCHAR(50);
   DECLARE @V_DSUSUARIO      VARCHAR(50);
   DECLARE @V_DSRDM          VARCHAR(50);
   DECLARE @V_DSMETODO       VARCHAR(250);
   DECLARE @V_DSOPERADOR     VARCHAR(12);
   DECLARE @V_QTANTRETIRADA  NUMERIC;
   DECLARE @V_QTATURETIRADA  NUMERIC;
   DECLARE @V_QTANTITEMRETI  NUMERIC;
   DECLARE @V_QTATUITEMRETI  NUMERIC;
   DECLARE @V_QTANTCARDADIA  NUMERIC;
   DECLARE @V_QTATUCARDADIA  NUMERIC;
   DECLARE @V_QTANTCOMPCARD  NUMERIC;
   DECLARE @V_QTATUCOMPCARD  NUMERIC;
   DECLARE @V_QTANTPREVRETI  NUMERIC;
   DECLARE @V_QTATUPREVRETI  NUMERIC;
   DECLARE @V_QTANTPREVCONS  NUMERIC;
   DECLARE @V_QTATUPREVCONS  NUMERIC;
   DECLARE @V_QTANTCONSSERV  NUMERIC;
   DECLARE @V_QTATUCONSSERV  NUMERIC;
   DECLARE @V_QTANTSERVTRAN  NUMERIC;
   DECLARE @V_QTATUSERVTRAN  NUMERIC;
   DECLARE @V_QTANTCUSTPADR  NUMERIC;
   DECLARE @V_QTATUCUSTPADR  NUMERIC;
   DECLARE @V_QTANTCUSTNESTO NUMERIC;
   DECLARE @V_QTATUCUSTNESTO NUMERIC;
   DECLARE @V_CDFILIAL       VARCHAR(4);

   DECLARE @V_RETIRADA_CDFILIAL    VARCHAR(4);
   DECLARE @V_RETIRADA_NRCARDAPIO  VARCHAR(10);
   DECLARE @V_RETIRADA_NRRETIRADA  VARCHAR(10);

   DECLARE @V_CARDADIA_NRCARDAPIO  VARCHAR(10);
   DECLARE @V_CARDADIA_CDFILIAL    VARCHAR(4);
   DECLARE @V_CARDADIA_DTCARDAPIO  DATETIME;

   DECLARE @V_PREVRETI_CDFILIAL      VARCHAR(4);
   DECLARE @V_PREVRETI_CDSERVFILI    VARCHAR(5);
   DECLARE @V_PREVRETI_DTPREVRETI    DATETIME;
   DECLARE @V_PREVRETI_NRREQUEXTR    VARCHAR(10);
   DECLARE @V_PREVRETI_IDPREVRETI    VARCHAR(1);
   DECLARE @V_PREVRETI_CDPRODUTO     VARCHAR(10);
   DECLARE @V_PREVRETI_DTLIMITERETI  DATETIME;
   DECLARE @V_PREVRETI_HRLIMITERETI  VARCHAR(4);
   DECLARE @V_PREVRETI_NRPRPREVRETI  VARCHAR(4);

   DECLARE @V_LOGPREVRETI_CDFILIAL      VARCHAR(4);
   DECLARE @V_LOGPREVRETI_CDOPERADOR    VARCHAR(12);
   DECLARE @V_LOGPREVRETI_DTHRCALCPR    DATETIME;
   DECLARE @V_LOGPREVRETI_CDSERVFILI    VARCHAR(5);
   DECLARE @V_LOGPREVRETI_NRCONSPLANPR  VARCHAR(10);

   DECLARE @V_PREVCONS_CDFILIAL    VARCHAR(4);
   DECLARE @V_PREVCONS_CDSERVFILI  VARCHAR(5);
   DECLARE @V_PREVCONS_CDPRODUTO   VARCHAR(10);
   DECLARE @V_PREVCONS_DTPREVCONS  DATETIME;

   DECLARE @V_LOGPREVCONS_CDFILIAL      VARCHAR(4);
   DECLARE @V_LOGPREVCONS_CDOPERADOR    VARCHAR(12);
   DECLARE @V_LOGPREVCONS_DTHRCALCPC    DATETIME;
   DECLARE @V_LOGPREVCONS_CDSERVFILI    VARCHAR(5);
   DECLARE @V_LOGPREVCONS_NRCONSPLANPC  VARCHAR(10);

   DECLARE @V_CONSSERV_CDFILIAL    VARCHAR(4);
   DECLARE @V_CONSSERV_CDSERVFILI  VARCHAR(5);
   DECLARE @V_CONSSERV_IDQTDECONS  VARCHAR(1);
   DECLARE @V_CONSSERV_IDTIPOCONS  VARCHAR(1);
   DECLARE @V_CONSSERV_DTCONSSERV  DATETIME;
   DECLARE @V_CONSSERV_CDPRODUTO   VARCHAR(10);

   DECLARE @V_DIASEMCONS_CDFILIAL     VARCHAR(4);
   DECLARE @V_DIASEMCONS_CDSERVFILI   VARCHAR(5);
   DECLARE @V_DIASEMCONS_DTSCONSSERV  DATETIME;

   DECLARE @V_LOGSUBCONSSER_DTOPERSUB DATETIME;
   DECLARE @V_LOGSUBCONSSER_CDOPERSUB VARCHAR(12);

   DECLARE @V_SERVTRAN_CDFILIAL       VARCHAR(4);
   DECLARE @V_SERVTRAN_CDSERVFILI     VARCHAR(5);
   DECLARE @V_SERVTRAN_DTSERVTRAN     DATETIME;
   DECLARE @V_SERVTRAN_CDFILAUXPRAT   VARCHAR(4);
   DECLARE @V_SERVTRAN_CDPRATO        VARCHAR(10);
   DECLARE @V_SERVTRAN_CDDIETPADST    VARCHAR(4);
   DECLARE @V_SERVTRAN_NRSERVTRAN     VARCHAR(10);

   DECLARE @V_LOGSERVTRAN_CDFILIAL    VARCHAR(4);
   DECLARE @V_LOGSERVTRAN_CDOPERADOR  VARCHAR(12);
   DECLARE @V_LOGSERVTRAN_DTHRCALCST  DATETIME;
   DECLARE @V_LOGSERVTRAN_CDSERVFILI  VARCHAR(5);

   DECLARE @V_CUSTPADR_CDFILIAL      VARCHAR(4);
   DECLARE @V_CUSTPADR_CDSERVFILI    VARCHAR(5);
   DECLARE @V_CUSTPADR_DTREFCUSPADR  DATETIME;

   DECLARE @V_CUSTNESTO_CDFILIAL     VARCHAR(4);
   DECLARE @V_CUSTNESTO_DTCUSTNESTO  DATETIME;
   DECLARE @V_CUSTNESTO_CDPRODUTO    VARCHAR(10);

BEGIN

   ALTER TABLE CARDADIA DISABLE TRIGGER LOG_PLA_CARDADIA;
   ALTER TABLE COMPCARD DISABLE TRIGGER LOG_PLA_COMPCARD;
   ALTER TABLE ITEMRETI DISABLE TRIGGER LOG_PLA_ITEMRETI;
   ALTER TABLE RETIRADA DISABLE TRIGGER LOG_PLA_RETIRADA;

   DELETE FROM CONSPLAN;

   DELETE FROM CONSPLANSE;

   DELETE FROM LOGINTCARD;

   DELETE FROM ITEMRETIPRAT;

   DELETE FROM LOGINTCARD;

   EXEC WEBTUNNING @V_DSIP,
                   @V_DSUSUARIO,
                   @V_DSRDM,
                   @V_DSMETODO,
                   @V_DSOPERADOR;

   DECLARE C_LISTA CURSOR FOR
      (SELECT CDLISTA AS CDFILIAL
       FROM LISTA
       WHERE NRLISTA = @P_NRLISTA);

   OPEN C_LISTA;

   FETCH NEXT FROM C_LISTA INTO @V_CDFILIAL

   WHILE (@@FETCH_STATUS = 0) BEGIN
      /* Deleta Retirada */
      SELECT @V_QTANTRETIRADA = COUNT(*)
      FROM RETIRADA;

      SELECT @V_QTANTITEMRETI = COUNT(*)
      FROM ITEMRETI;

      DECLARE C_RETIRADA CURSOR FOR
        (SELECT
            RETIRADA.CDFILIAL,
            RETIRADA.NRCARDAPIO,
            RETIRADA.NRRETIRADA
         FROM
            RETIRADA
         WHERE
            (RETIRADA.CDFILIAL    = @V_CDFILIAL) AND
            (RETIRADA.DTRETIRADA <= @P_DTFINAL))

      OPEN C_RETIRADA;
      FETCH NEXT FROM C_RETIRADA INTO @V_RETIRADA_CDFILIAL ,
                                      @V_RETIRADA_NRCARDAPIO,
                                      @V_RETIRADA_NRRETIRADA;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         DELETE FROM RETIRADA
         WHERE
            (RETIRADA.CDFILIAL   = @V_RETIRADA_CDFILIAL  ) AND
            (RETIRADA.NRCARDAPIO = @V_RETIRADA_NRCARDAPIO) AND
            (RETIRADA.NRRETIRADA = @V_RETIRADA_NRRETIRADA);

         FETCH NEXT FROM C_RETIRADA INTO @V_RETIRADA_CDFILIAL,
                                         @V_RETIRADA_NRCARDAPIO,
                                         @V_RETIRADA_NRRETIRADA;
      END;
      CLOSE C_RETIRADA;
      DEALLOCATE C_RETIRADA;

      SELECT @V_QTATURETIRADA = COUNT(*)
      FROM RETIRADA;

      SELECT @V_QTATUITEMRETI = COUNT(*)
      FROM ITEMRETI;

      INSERT INTO LOGLIMPEZA
         (DSSISTLIMPEZ, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, NMTABLIMP, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTLINHAANT, QTLINHAATU)
      VALUES
         (@P_DSSISTLIMPEZ, GETDATE(), @P_NMOPERLIMPEZ, @P_DTFINAL, 'RETIRADA', 'RETIRADA', @V_DSRDM, @V_DSIP, @V_DSUSUARIO, @V_DSMETODO, @V_QTANTRETIRADA, @V_QTATURETIRADA);

      INSERT INTO LOGLIMPEZA
         (DSSISTLIMPEZ, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, NMTABLIMP, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTLINHAANT, QTLINHAATU)
      VALUES
         (@P_DSSISTLIMPEZ, GETDATE(), @P_NMOPERLIMPEZ, @P_DTFINAL, 'ITEMRETI', 'ITEMRETI', @V_DSRDM, @V_DSIP, @V_DSUSUARIO, @V_DSMETODO, @V_QTANTITEMRETI, @V_QTATUITEMRETI);

      /* Deleta CARDAPIO */
      SELECT @V_QTANTCARDADIA = COUNT(*)
      FROM CARDADIA;

      SELECT @V_QTANTCOMPCARD = COUNT(*)
      FROM COMPCARD;

      DECLARE C_CARDADIA CURSOR FOR
         (SELECT
             CARDADIA.NRCARDAPIO,
             CARDADIA.CDFILIAL,
             CARDADIA.DTCARDAPIO
          FROM
            CARDADIA
          WHERE
            (CARDADIA.CDFILIAL    = @V_CDFILIAL) AND
            (CARDADIA.DTCARDAPIO <= @P_DTFINAL))

      OPEN C_CARDADIA;
      FETCH NEXT FROM C_CARDADIA INTO @V_CARDADIA_NRCARDAPIO,
                                      @V_CARDADIA_CDFILIAL,
                                      @V_CARDADIA_DTCARDAPIO;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         DELETE FROM COMPCARD
         WHERE
            (COMPCARD.NRCARDAPIO = @V_CARDADIA_NRCARDAPIO) AND
            (COMPCARD.CDFILIAL   = @V_CARDADIA_CDFILIAL  );

         DELETE FROM CNFCAMES
         WHERE
            (CNFCAMES.CDFILIAL      = @V_CARDADIA_CDFILIAL) AND
            (CNFCAMES.DTREFECNFMES <= @P_DTFINAL);

         DELETE FROM CARDADIA
         WHERE
            (CARDADIA.NRCARDAPIO = @V_CARDADIA_NRCARDAPIO) AND
            (CARDADIA.CDFILIAL   = @V_CARDADIA_CDFILIAL  ) AND
            (CARDADIA.DTCARDAPIO = @V_CARDADIA_DTCARDAPIO);

         FETCH NEXT FROM C_CARDADIA INTO @V_CARDADIA_NRCARDAPIO,
                                         @V_CARDADIA_CDFILIAL,
                                         @V_CARDADIA_DTCARDAPIO;
      END;
      CLOSE C_CARDADIA;
      DEALLOCATE C_CARDADIA;

      SELECT @V_QTATUCARDADIA = COUNT(*)
      FROM CARDADIA;

      SELECT @V_QTATUCOMPCARD = COUNT(*)
      FROM COMPCARD;

      INSERT INTO LOGLIMPEZA
         (DSSISTLIMPEZ, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, NMTABLIMP, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTLINHAANT, QTLINHAATU)
      VALUES
         (@P_DSSISTLIMPEZ, GETDATE(), @P_NMOPERLIMPEZ, @P_DTFINAL, 'CARDADIA', 'CARDADIA', @V_DSRDM, @V_DSIP, @V_DSUSUARIO, @V_DSMETODO, @V_QTANTCARDADIA, @V_QTATUCARDADIA);


      INSERT INTO LOGLIMPEZA
        (DSSISTLIMPEZ, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, NMTABLIMP, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTLINHAANT, QTLINHAATU)
      VALUES
        (@P_DSSISTLIMPEZ, GETDATE(), @P_NMOPERLIMPEZ, @P_DTFINAL, 'COMPCARD', 'COMPCARD', @V_DSRDM, @V_DSIP, @V_DSUSUARIO, @V_DSMETODO, @V_QTANTCOMPCARD, @V_QTATUCOMPCARD);

      /* Deleta A Requisio*/
      SELECT @V_QTANTPREVRETI = COUNT(*)
      FROM PREVRETI;

      DECLARE C_PREVRETI CURSOR FOR
         (SELECT
             PREVRETI.CDFILIAL,
             PREVRETI.CDSERVFILI,
             PREVRETI.DTPREVRETI,
             PREVRETI.NRREQUEXTR,
             PREVRETI.IDPREVRETI,
             PREVRETI.CDPRODUTO,
             PREVRETI.DTLIMITERETI,
             PREVRETI.HRLIMITERETI,
             PREVRETI.NRPRPREVRETI
          FROM
             PREVRETI
          WHERE
              (PREVRETI.CDFILIAL   =  @V_CDFILIAL) AND
              (PREVRETI.DTPREVRETI <= @P_DTFINAL ))

      OPEN C_PREVRETI;
      FETCH NEXT FROM C_PREVRETI INTO @V_PREVRETI_CDFILIAL,
                                      @V_PREVRETI_CDSERVFILI,
                                      @V_PREVRETI_DTPREVRETI,
                                      @V_PREVRETI_NRREQUEXTR,
                                      @V_PREVRETI_IDPREVRETI,
                                      @V_PREVRETI_CDPRODUTO,
                                      @V_PREVRETI_DTLIMITERETI,
                                      @V_PREVRETI_HRLIMITERETI,
                                      @V_PREVRETI_NRPRPREVRETI;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         DELETE FROM PREVRETI
         WHERE
            (PREVRETI.CDFILIAL     =  @V_PREVRETI_CDFILIAL    ) AND
            (PREVRETI.CDSERVFILI   =  @V_PREVRETI_CDSERVFILI  ) AND
            (PREVRETI.DTPREVRETI   =  @V_PREVRETI_DTPREVRETI  ) AND
            (PREVRETI.NRREQUEXTR   =  @V_PREVRETI_NRREQUEXTR  ) AND
            (PREVRETI.IDPREVRETI   =  @V_PREVRETI_IDPREVRETI  ) AND
            (PREVRETI.CDPRODUTO    =  @V_PREVRETI_CDPRODUTO   ) AND
            (PREVRETI.DTLIMITERETI =  @V_PREVRETI_DTLIMITERETI) AND
            (PREVRETI.HRLIMITERETI =  @V_PREVRETI_HRLIMITERETI) AND
            (PREVRETI.NRPRPREVRETI =  @V_PREVRETI_NRPRPREVRETI);

            FETCH NEXT FROM C_PREVRETI INTO @V_PREVRETI_CDFILIAL,
                                            @V_PREVRETI_CDSERVFILI,
                                            @V_PREVRETI_DTPREVRETI,
                                            @V_PREVRETI_NRREQUEXTR,
                                            @V_PREVRETI_IDPREVRETI,
                                            @V_PREVRETI_CDPRODUTO,
                                            @V_PREVRETI_DTLIMITERETI,
                                            @V_PREVRETI_HRLIMITERETI,
                                            @V_PREVRETI_NRPRPREVRETI;
      END;
      CLOSE C_PREVRETI;
      DEALLOCATE C_PREVRETI;

      SELECT @V_QTATUPREVRETI = COUNT(*)
      FROM PREVRETI;

      INSERT INTO LOGLIMPEZA
         (DSSISTLIMPEZ, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, NMTABLIMP, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTLINHAANT, QTLINHAATU)
      VALUES
         (@P_DSSISTLIMPEZ, GETDATE(), @P_NMOPERLIMPEZ, @P_DTFINAL, 'PREVRETI', 'PREVRETI', @V_DSRDM, @V_DSIP, @V_DSUSUARIO, @V_DSMETODO, @V_QTANTPREVRETI, @V_QTATUPREVRETI);

      /* Deleta Log da Requisicao */
      DECLARE C_LOGPREVRETI CURSOR FOR
         (SELECT
             LOGPREVRETI.CDFILIAL,
             LOGPREVRETI.CDOPERADOR,
             LOGPREVRETI.DTHRCALCPR,
             LOGPREVRETI.CDSERVFILI,
             LOGPREVRETI.NRCONSPLANPR
          FROM
             LOGPREVRETI
          WHERE
             (CDFILIAL   = @V_CDFILIAL) AND
             (DTHRCALCPR <= @P_DTFINAL))

      OPEN C_LOGPREVRETI;
      FETCH NEXT FROM C_LOGPREVRETI INTO @V_LOGPREVRETI_CDFILIAL,
                                         @V_LOGPREVRETI_CDOPERADOR,
                                         @V_LOGPREVRETI_DTHRCALCPR,
                                         @V_LOGPREVRETI_CDSERVFILI,
                                         @V_LOGPREVRETI_NRCONSPLANPR;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         DELETE FROM LOGPREVRETI
         WHERE
             (LOGPREVRETI.CDFILIAL     = @V_LOGPREVRETI_CDFILIAL    ) AND
             (LOGPREVRETI.CDOPERADOR   = @V_LOGPREVRETI_CDOPERADOR  ) AND
             (LOGPREVRETI.DTHRCALCPR   = @V_LOGPREVRETI_DTHRCALCPR  ) AND
             (LOGPREVRETI.CDSERVFILI   = @V_LOGPREVRETI_CDSERVFILI  ) AND
             (LOGPREVRETI.NRCONSPLANPR = @V_LOGPREVRETI_NRCONSPLANPR);


         FETCH NEXT FROM C_LOGPREVRETI INTO @V_LOGPREVRETI_CDFILIAL,
                                            @V_LOGPREVRETI_CDOPERADOR,
                                            @V_LOGPREVRETI_DTHRCALCPR,
                                            @V_LOGPREVRETI_CDSERVFILI,
                                            @V_LOGPREVRETI_NRCONSPLANPR;
      END;
      CLOSE C_LOGPREVRETI;
      DEALLOCATE C_LOGPREVRETI;


      /*Deleta Previso de Consumo */
      SELECT @V_QTANTPREVCONS = COUNT(*)
      FROM PREVCONS;

      DECLARE  C_PREVCONS CURSOR FOR
         (SELECT
             PREVCONS.CDFILIAL,
             PREVCONS.CDSERVFILI,
             PREVCONS.CDPRODUTO,
             PREVCONS.DTPREVCONS
          FROM
             PREVCONS
          WHERE
             (PREVCONS.CDFILIAL   = @V_CDFILIAL) AND
             (PREVCONS.DTPREVCONS <= @P_DTFINAL))

      OPEN C_PREVCONS;
      FETCH NEXT FROM C_PREVCONS INTO @V_PREVCONS_CDFILIAL,
                                      @V_PREVCONS_CDSERVFILI,
                                      @V_PREVCONS_CDPRODUTO,
                                      @V_PREVCONS_DTPREVCONS;

      WHILE (@@FETCH_STATUS = 0)
      BEGIN

         DELETE FROM PREVCONS
         WHERE
            (PREVCONS.CDFILIAL   = @V_PREVCONS_CDFILIAL  ) AND
            (PREVCONS.CDSERVFILI = @V_PREVCONS_CDSERVFILI) AND
            (PREVCONS.CDPRODUTO  = @V_PREVCONS_CDPRODUTO ) AND
            (PREVCONS.DTPREVCONS = @V_PREVCONS_DTPREVCONS);

         FETCH NEXT FROM C_PREVCONS INTO @V_PREVCONS_CDFILIAL,
                                         @V_PREVCONS_CDSERVFILI,
                                         @V_PREVCONS_CDPRODUTO,
                                         @V_PREVCONS_DTPREVCONS;
      END;
      CLOSE C_PREVCONS;
      DEALLOCATE C_PREVCONS;

      SELECT @V_QTATUPREVCONS = COUNT(*)
      FROM PREVCONS;

      INSERT INTO LOGLIMPEZA
         (DSSISTLIMPEZ, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, NMTABLIMP, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTLINHAANT, QTLINHAATU)
      VALUES
         (@P_DSSISTLIMPEZ, GETDATE(), @P_NMOPERLIMPEZ, @P_DTFINAL, 'PREVCONS', 'PREVCONS', @V_DSRDM, @V_DSIP, @V_DSUSUARIO, @V_DSMETODO, @V_QTANTPREVCONS, @V_QTATUPREVCONS);

      /* Deleta Log da Previso de Consumo */
      DECLARE C_LOGPREVCONS CURSOR FOR
         (SELECT
             LOGPREVCONS.CDFILIAL,
             LOGPREVCONS.CDOPERADOR,
             LOGPREVCONS.DTHRCALCPC,
             LOGPREVCONS.CDSERVFILI,
             LOGPREVCONS.NRCONSPLANPC
          FROM
             LOGPREVCONS
          WHERE
             (CDFILIAL    = @V_CDFILIAL) AND
             (DTHRCALCPC <= @P_DTFINAL))

      OPEN C_LOGPREVCONS;
      FETCH NEXT FROM C_LOGPREVCONS INTO @V_LOGPREVCONS_CDFILIAL,
                                         @V_LOGPREVCONS_CDOPERADOR,
                                         @V_LOGPREVCONS_DTHRCALCPC,
                                         @V_LOGPREVCONS_CDSERVFILI,
                                         @V_LOGPREVCONS_NRCONSPLANPC;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         DELETE FROM LOGPREVCONS
         WHERE
            (LOGPREVCONS.CDFILIAL     = @V_LOGPREVCONS_CDFILIAL    ) AND
            (LOGPREVCONS.CDOPERADOR   = @V_LOGPREVCONS_CDOPERADOR  ) AND
            (LOGPREVCONS.DTHRCALCPC   = @V_LOGPREVCONS_DTHRCALCPC  ) AND
            (LOGPREVCONS.CDSERVFILI   = @V_LOGPREVCONS_CDSERVFILI  ) AND
            (LOGPREVCONS.NRCONSPLANPC = @V_LOGPREVCONS_NRCONSPLANPC);

         FETCH NEXT FROM C_LOGPREVCONS INTO @V_LOGPREVCONS_CDFILIAL,
                                            @V_LOGPREVCONS_CDOPERADOR,
                                            @V_LOGPREVCONS_DTHRCALCPC,
                                            @V_LOGPREVCONS_CDSERVFILI,
                                            @V_LOGPREVCONS_NRCONSPLANPC;
      END;
      CLOSE C_LOGPREVCONS;
      DEALLOCATE C_LOGPREVCONS;

      /* Deleta Consumo por Servio */
      SELECT @V_QTANTCONSSERV = COUNT(*)
      FROM CONSSERV;

      DECLARE C_CONSSERV CURSOR FOR
         (SELECT
             CONSSERV.CDFILIAL,
             CONSSERV.CDSERVFILI,
             CONSSERV.IDQTDECONS,
             CONSSERV.IDTIPOCONS,
             CONSSERV.DTCONSSERV,
             CONSSERV.CDPRODUTO
          FROM
             CONSSERV
          WHERE
              (CONSSERV.CDFILIAL   = @V_CDFILIAL) AND
              (CONSSERV.DTCONSSERV <= @P_DTFINAL))

      OPEN C_CONSSERV;
      FETCH NEXT FROM C_CONSSERV INTO @V_CONSSERV_CDFILIAL,
                                      @V_CONSSERV_CDSERVFILI,
                                      @V_CONSSERV_IDQTDECONS,
                                      @V_CONSSERV_IDTIPOCONS,
                                      @V_CONSSERV_DTCONSSERV,
                                      @V_CONSSERV_CDPRODUTO;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         DELETE FROM CONSSERV
         WHERE
            (CONSSERV.CDFILIAL   = @V_CDFILIAL) AND
            (CONSSERV.DTCONSSERV <= @P_DTFINAL);

         FETCH NEXT FROM C_CONSSERV INTO @V_CONSSERV_CDFILIAL,
                                         @V_CONSSERV_CDSERVFILI,
                                         @V_CONSSERV_IDQTDECONS,
                                         @V_CONSSERV_IDTIPOCONS,
                                         @V_CONSSERV_DTCONSSERV,
                                         @V_CONSSERV_CDPRODUTO;
      END;
      CLOSE C_CONSSERV;
      DEALLOCATE C_CONSSERV;


      SELECT @V_QTATUCONSSERV = COUNT(*)
      FROM CONSSERV;

      INSERT INTO LOGLIMPEZA
         (DSSISTLIMPEZ, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, NMTABLIMP, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTLINHAANT, QTLINHAATU)
      VALUES
         (@P_DSSISTLIMPEZ, GETDATE(), @P_NMOPERLIMPEZ, @P_DTFINAL, 'CONSSERV', 'CONSSERV', @V_DSRDM, @V_DSIP, @V_DSUSUARIO, @V_DSMETODO, @V_QTANTCONSSERV, @V_QTATUCONSSERV);

      DECLARE C_DIASEMCONS CURSOR FOR
         (SELECT
             DIASEMCONS.CDFILIAL,
             DIASEMCONS.CDSERVFILI,
             DIASEMCONS.DTSCONSSERV
          FROM
             DIASEMCONS
          WHERE
             (CDFILIAL = @V_CDFILIAL) AND
             (DTSCONSSERV <= @P_DTFINAL))

      OPEN C_DIASEMCONS;
      FETCH NEXT FROM C_DIASEMCONS INTO @V_DIASEMCONS_CDFILIAL,
                                        @V_DIASEMCONS_CDSERVFILI,
                                        @V_DIASEMCONS_DTSCONSSERV;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         DELETE DIASEMCONS
         WHERE
            (DIASEMCONS.CDFILIAL    = @V_DIASEMCONS_CDFILIAL   ) AND
            (DIASEMCONS.CDSERVFILI  = @V_DIASEMCONS_CDSERVFILI ) AND
            (DIASEMCONS.DTSCONSSERV = @V_DIASEMCONS_DTSCONSSERV);

         FETCH NEXT FROM C_DIASEMCONS INTO @V_DIASEMCONS_CDFILIAL,
                                           @V_DIASEMCONS_CDSERVFILI,
                                           @V_DIASEMCONS_DTSCONSSERV;

      END;
      CLOSE C_DIASEMCONS;
      DEALLOCATE C_DIASEMCONS;

      /* Deleta Log de Substituio de Cons. Servio */
      DECLARE C_LOGSUBCONSSER CURSOR FOR
         (SELECT
             LOGSUBCONSSER.DTOPERSUB,
             LOGSUBCONSSER.CDOPERSUB
          FROM
             LOGSUBCONSSER
          WHERE
             (DTOPERSUB <= @P_DTFINAL))

      OPEN C_LOGSUBCONSSER;
      FETCH NEXT FROM C_LOGSUBCONSSER INTO @V_LOGSUBCONSSER_DTOPERSUB,
                                           @V_LOGSUBCONSSER_CDOPERSUB;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         DELETE FROM LOGSUBCONSSER
         WHERE
            (LOGSUBCONSSER.DTOPERSUB = @V_LOGSUBCONSSER_DTOPERSUB) AND
            (LOGSUBCONSSER.CDOPERSUB = @V_LOGSUBCONSSER_CDOPERSUB);

         FETCH NEXT FROM C_LOGSUBCONSSER INTO @V_LOGSUBCONSSER_DTOPERSUB,
                                              @V_LOGSUBCONSSER_CDOPERSUB;

      END;
      CLOSE C_LOGSUBCONSSER;
      DEALLOCATE C_LOGSUBCONSSER;

      /* Servios transportado */
      SELECT @V_QTANTSERVTRAN = COUNT(*)
      FROM SERVTRAN;

      DECLARE C_SERVTRAN CURSOR FOR
         (SELECT
             SERVTRAN.CDFILIAL,
             SERVTRAN.CDSERVFILI,
             SERVTRAN.DTSERVTRAN,
             SERVTRAN.CDFILAUXPRAT,
             SERVTRAN.CDPRATO,
             SERVTRAN.CDDIETPADST,
             SERVTRAN.NRSERVTRAN
          FROM
             SERVTRAN
          WHERE
             (SERVTRAN.CDFILIAL = @V_CDFILIAL) AND
             (SERVTRAN.DTSERVTRAN <= @P_DTFINAL))

      OPEN C_SERVTRAN;
      FETCH NEXT FROM C_SERVTRAN INTO @V_SERVTRAN_CDFILIAL,
                                      @V_SERVTRAN_CDSERVFILI,
                                      @V_SERVTRAN_DTSERVTRAN,
                                      @V_SERVTRAN_CDFILAUXPRAT,
                                      @V_SERVTRAN_CDPRATO,
                                      @V_SERVTRAN_CDDIETPADST,
                                      @V_SERVTRAN_NRSERVTRAN;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         DELETE FROM SERVTRAN
         WHERE
            (SERVTRAN.CDFILIAL     = @V_SERVTRAN_CDFILIAL    ) AND
            (SERVTRAN.CDSERVFILI   = @V_SERVTRAN_CDSERVFILI  ) AND
            (SERVTRAN.DTSERVTRAN   = @V_SERVTRAN_DTSERVTRAN  ) AND
            (SERVTRAN.CDFILAUXPRAT = @V_SERVTRAN_CDFILAUXPRAT) AND
            (SERVTRAN.CDPRATO      = @V_SERVTRAN_CDPRATO     ) AND
            (SERVTRAN.CDDIETPADST  = @V_SERVTRAN_CDDIETPADST ) AND
            (SERVTRAN.NRSERVTRAN   = @V_SERVTRAN_NRSERVTRAN  );


         FETCH NEXT FROM C_SERVTRAN INTO @V_SERVTRAN_CDFILIAL,
                                         @V_SERVTRAN_CDSERVFILI,
                                         @V_SERVTRAN_DTSERVTRAN,
                                         @V_SERVTRAN_CDFILAUXPRAT,
                                         @V_SERVTRAN_CDPRATO,
                                         @V_SERVTRAN_CDDIETPADST,
                                         @V_SERVTRAN_NRSERVTRAN;
      END;
      CLOSE C_SERVTRAN;
      DEALLOCATE C_SERVTRAN;

      SELECT @V_QTATUSERVTRAN = COUNT(*)
      FROM SERVTRAN;

      INSERT INTO LOGLIMPEZA
         (DSSISTLIMPEZ, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, NMTABLIMP, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTLINHAANT, QTLINHAATU)
      VALUES
         (@P_DSSISTLIMPEZ, GETDATE(), @P_NMOPERLIMPEZ, @P_DTFINAL, 'SERVTRAN', 'SERVTRAN', @V_DSRDM, @V_DSIP, @V_DSUSUARIO, @V_DSMETODO, @V_QTANTSERVTRAN, @V_QTATUSERVTRAN);


      DECLARE C_LOGSERVTRAN CURSOR FOR
         (SELECT
             LOGSERVTRAN.CDFILIAL,
             LOGSERVTRAN.CDOPERADOR,
             LOGSERVTRAN.DTHRCALCST,
             LOGSERVTRAN.CDSERVFILI
          FROM
             LOGSERVTRAN
          WHERE
             (LOGSERVTRAN.CDFILIAL = @V_CDFILIAL) AND
             (LOGSERVTRAN.DTHRCALCST <= @P_DTFINAL))

      OPEN C_LOGSERVTRAN;
      FETCH NEXT FROM C_LOGSERVTRAN INTO @V_LOGSERVTRAN_CDFILIAL,
                                         @V_LOGSERVTRAN_CDOPERADOR,
                                         @V_LOGSERVTRAN_DTHRCALCST,
                                         @V_LOGSERVTRAN_CDSERVFILI;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         DELETE FROM LOGSERVTRAN
         WHERE
            (LOGSERVTRAN.CDFILIAL   = @V_LOGSERVTRAN_CDFILIAL  ) AND
            (LOGSERVTRAN.CDOPERADOR = @V_LOGSERVTRAN_CDOPERADOR) AND
            (LOGSERVTRAN.DTHRCALCST = @V_LOGSERVTRAN_DTHRCALCST) AND
            (LOGSERVTRAN.CDSERVFILI = @V_LOGSERVTRAN_CDSERVFILI);

         FETCH NEXT FROM C_LOGSERVTRAN INTO @V_LOGSERVTRAN_CDFILIAL,
                                            @V_LOGSERVTRAN_CDOPERADOR,
                                            @V_LOGSERVTRAN_DTHRCALCST,
                                            @V_LOGSERVTRAN_CDSERVFILI;
      END;
      CLOSE C_LOGSERVTRAN;
      DEALLOCATE C_LOGSERVTRAN;


      /* Custo padrao */
      SELECT @V_QTANTCUSTPADR = COUNT(*)
      FROM CUSTPADR;

      DECLARE C_CUSTPADR CURSOR FOR
         (SELECT
             CUSTPADR.CDFILIAL,
             CUSTPADR.CDSERVFILI,
             CUSTPADR.DTREFCUSPADR
         FROM
            CUSTPADR
         WHERE
            (CUSTPADR.CDFILIAL = @V_CDFILIAL) AND
            (CUSTPADR.DTREFCUSPADR <= @P_DTFINAL))

      OPEN C_CUSTPADR;
      FETCH NEXT FROM C_CUSTPADR INTO @V_CUSTPADR_CDFILIAL,
                                      @V_CUSTPADR_CDSERVFILI,
                                      @V_CUSTPADR_DTREFCUSPADR;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         DELETE FROM CUSTPADR
         WHERE
            (CUSTPADR.CDFILIAL     = @V_CUSTPADR_CDFILIAL    ) AND
            (CUSTPADR.CDSERVFILI   = @V_CUSTPADR_CDSERVFILI  ) AND
            (CUSTPADR.DTREFCUSPADR = @V_CUSTPADR_DTREFCUSPADR);

         FETCH NEXT FROM C_CUSTPADR INTO @V_CUSTPADR_CDFILIAL,
                                         @V_CUSTPADR_CDSERVFILI,
                                         @V_CUSTPADR_DTREFCUSPADR;
      END;
      CLOSE C_CUSTPADR;
      DEALLOCATE C_CUSTPADR;

      SELECT @V_QTATUCUSTPADR = COUNT(*)
      FROM CUSTPADR;

      INSERT INTO LOGLIMPEZA
         (DSSISTLIMPEZ, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, NMTABLIMP, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTLINHAANT, QTLINHAATU)
      VALUES
         (@P_DSSISTLIMPEZ, GETDATE(), @P_NMOPERLIMPEZ, @P_DTFINAL, 'CUSTPADR', 'CUSTPADR', @V_DSRDM, @V_DSIP, @V_DSUSUARIO, @V_DSMETODO, @V_QTANTCUSTPADR, @V_QTATUCUSTPADR);


      /* Custo nao estocaveis */
      SELECT @V_QTANTCUSTNESTO = COUNT(*)
      FROM CUSTNESTO;

      DECLARE C_CUSTNESTO CURSOR FOR
         (SELECT
             CUSTNESTO.CDFILIAL,
             CUSTNESTO.DTCUSTNESTO,
             CUSTNESTO.CDPRODUTO
          FROM
             CUSTNESTO
          WHERE
              (CUSTNESTO.CDFILIAL = @V_CDFILIAL) AND
              (CUSTNESTO.DTCUSTNESTO <= @P_DTFINAL))

      OPEN C_CUSTNESTO;
      FETCH NEXT FROM C_CUSTNESTO INTO @V_CUSTNESTO_CDFILIAL,
                                       @V_CUSTNESTO_DTCUSTNESTO,
                                       @V_CUSTNESTO_CDPRODUTO;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         DELETE FROM CUSTNESTO
         WHERE
            (CUSTNESTO.CDFILIAL    = @V_CUSTNESTO_CDFILIAL   ) AND
            (CUSTNESTO.DTCUSTNESTO = @V_CUSTNESTO_DTCUSTNESTO) AND
            (CUSTNESTO.CDPRODUTO   = @V_CUSTNESTO_CDPRODUTO  );

         FETCH NEXT FROM C_CUSTNESTO INTO @V_CUSTNESTO_CDFILIAL,
                                          @V_CUSTNESTO_DTCUSTNESTO,
                                          @V_CUSTNESTO_CDPRODUTO;
      END;
      CLOSE C_CUSTNESTO;
      DEALLOCATE C_CUSTNESTO;

      SELECT @V_QTATUCUSTNESTO = COUNT(*)
      FROM CUSTNESTO;

      INSERT INTO LOGLIMPEZA
         (DSSISTLIMPEZ, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, NMTABLIMP, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTLINHAANT, QTLINHAATU)
      VALUES
         (@P_DSSISTLIMPEZ, GETDATE(), @P_NMOPERLIMPEZ, @P_DTFINAL, 'CUSTNESTO', 'CUSTNESTO', @V_DSRDM, @V_DSIP, @V_DSUSUARIO, @V_DSMETODO, @V_QTANTCUSTNESTO, @V_QTATUCUSTNESTO);

      FETCH NEXT FROM C_LISTA INTO @V_CDFILIAL;

  END;
  CLOSE C_LISTA;
  DEALLOCATE C_LISTA;

  ALTER TABLE CARDADIA ENABLE TRIGGER LOG_PLA_CARDADIA;
  ALTER TABLE COMPCARD ENABLE TRIGGER LOG_PLA_COMPCARD;
  ALTER TABLE ITEMRETI ENABLE TRIGGER LOG_PLA_ITEMRETI;
  ALTER TABLE RETIRADA ENABLE TRIGGER LOG_PLA_RETIRADA;

END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LIMPA_TABELAS_PLA','5.05.012';
GO

